      subroutine  newton(r_l0,m_l0,r_r0,m_r0,labelLgth,label,r,m)
      implicit none
c
c
      include 'parameters.h'
      include 'input_output.h'
      include 'wave_constants.h'

      integer NITER
      parameter (NITER=100)
      real*8 raccur
      parameter (raccur = rho_min)

c     Input:
      real*8 r_l0,m_l0,r_r0,m_r0
      integer labelLgth
      character*80 label
c     Output:
      real*8 r,m
c     Auxiliary:
      real*8 z_l,z_r,m_l,m_r, dr,onWaveCurve
      external rho2DmomDrhoExpan,rho2DmomDrhoCompr
      real*8 rho2DmomDrhoExpan,rho2DmomDrhoCompr
      integer i

      if (PRINT_NEWTON) then
         write(*,*) r_l0,m_l0,r_r0,m_r0
      endif

      if (PRINT_NEWTON_CONV) then
         open(fid_l,file='rm_conv_l_' // label(1:labelLgth) // '.dat')
         open(fid_r,file='rm_conv_r_' // label(1:labelLgth) // '.dat')
      endif

      z_l = onWaveCurve(r_l0,r_l0,m_l0,DIR_L,AHEAD,
     &     rho2DmomDrhoExpan,rho2DmomDrhoCompr)
      z_r = onWaveCurve(r_r0,r_r0,m_r0,DIR_R,AHEAD,
     &     rho2DmomDrhoExpan,rho2DmomDrhoCompr)

      r = (z_r*r_r0 - z_l*r_l0 - (m_r0-m_l0))/(z_r-z_l)

c      dr = 0.5d0*((r-r_l0) + (r-r_r0))
c      dr = 1.d0*(r-dmin1(r_l0,r_r0)) + 1.d0*(r-dmax1(r_l0,r_r0))

      if (PRINT_NEWTON) then
         write(*,*) label,': Begin Newton Iterations'
      endif

      do i=1,NITER
         if( r .le. rho_min ) then
            r = 2.d0*dmax1(r_l0,r_r0)
c            r = 0.5d0*(rho_min + (r - dr))
         endif

         call valueAndSlope(r,r_l0,m_l0,DIR_L,AHEAD, z_l,m_l)
         call valueAndSlope(r,r_r0,m_r0,DIR_R,AHEAD, z_r,m_r)

         if (PRINT_NEWTON_CONV) then
            write(fid_l,1000) r,m_l
            write(fid_r,1000) r,m_r
         endif
         
         dr=-(m_r-m_l)/(z_r-z_l)

         if (PRINT_NEWTON) then
            write(*,*) i, dr
         endif

         if (dabs(dr) .lt. raccur) then

            m=(m_l*z_r-m_r*z_l)/(z_r-z_l)

            if (PRINT_NEWTON_CONV) then
               close(fid_l)
               close(fid_r)
            endif
            return
         endif

         r = r + dr
      enddo
      if (PRINT_NEWTON_CONV) then
         close(fid_l)
         close(fid_r)
      endif

      write(*,*)
      write(*,*) ' newton: Number of iterations exceeded',NITER
      stop

1000  format(2g26.18E2)
      end


