      program testNewt
      implicit none

      include 'input_output.h'
      include 'wave_constants.h'

c     Input:
      real*8 rho_l0,mom_l0,rho_r0,mom_r0
      real*8 cfl
c     Auxiliary:
      real*8 rho_0(N_STATES),mom_0(N_STATES),w_0(N_EDGES)
      integer signif_0(N_WAVES),wave_type_0(N_WAVES)
      integer labelLgth
      character*80 label
      real*8 xM,dxL,dxR,xL,xR,timeL,timeR,time,maxTime

      call readEOSConst()

      open(fid,file='newt.inp',status='old')
      read(fid,*) rho_l0,mom_l0,rho_r0,mom_r0,cfl
      read(fid,*) PRINT_NEWTON
      read(fid,*) PRINT_NEWTON_CONV
      read(fid,*) PRINT_RP
      read(fid,*) PRINT_WC
      read(fid,*) PRINT_INIT_WC
      close(fid)

      write(*,*) rho_l0,mom_l0
      write(*,*) rho_r0,mom_r0
      write(*,*)

      label = 'test'
      labelLgth = index(label,' ')-1

      call riemann(     
     &     rho_l0,mom_l0,rho_r0,mom_r0,labelLgth,label,
     &     rho_0,mom_0,w_0,signif_0,wave_type_0)

      xM = 0.d0
      dxL = 1.d0
      dxR = 1.d0
      xL = xM - dxL
      xR = xM + dxR
      timeL = maxTime(rho_l0,mom_l0,dxL) 
      timeR = maxTime(rho_r0,mom_r0,dxR) 
      time = cfl*dmin1(timeL,timeR)

      call rpSnapshot(rho_0,mom_0,w_0,signif_0,wave_type_0,
     &     xL,xM,xR,time,labelLgth,label)

      end
